<?php

namespace Intergo\AuthClient\Enums;

class UserStatusEnum
{
    const ACTIVE = 'active';
    const INACTIVE = 'inactive';
    const PRE_ACTIVE= 'pre_active';
    const PRE_INACTIVE='pre_inactive';

    const INACTIVE_PERIOD_IN_DAYS = 180;

    /**
     * @return array<string>
     */
    public static function preStatuses(): array
    {
        return [
            self::PRE_ACTIVE,
            self::PRE_INACTIVE
        ];
    }

    /**
     * @return array<string>
     */
    public static function allowToBeActive(): array
    {
        return array_merge([
            self::INACTIVE
        ], static::preStatuses());
    }

    /**
     * @return array<string>
     */
    public static function allowToBeInactive(): array
    {
        return array_merge([
            self::ACTIVE
        ], static::preStatuses());
    }


    /**
     * @param $status
     * @return bool
     */
    public static function isEligibleToBeActive($status): bool
    {
        return in_array($status, self::allowToBeActive());
    }
}